> For the complete documentation index, see [llms.txt](https://docs.mapsindoors.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mapsindoors.com/sdks-and-frameworks/flutter/migration-guide.md).

# Migration Guide

This page describes how to migrate between major versions

## Migrating from v3 to v4

### Color `String` to `Color`

All references to colors in the SDK have been changed from using a color string (which can be ambiguous in whether `aRGB` or `RGBa` is meant to be used) to using Dart `Color` instead.

{% tabs %}
{% tab title="Before" %}

```dart
final displayrule = await getMainDisplayRule();
displayrule.setLabelStyleTextColor("#FF00FF00"); // Red or transparent Purple?
```

{% endtab %}

{% tab title="After" %}

```dart
final displayrule = await getMainDisplayRule();
displayrule.setLabelStyleTextColor(Colors.red); // Definitely red
```

{% endtab %}
{% endtabs %}

### Label position

The default label position has been changed from right of the Marker to underneath the marker.

It will not be possible with the 4.0.0 to programatically change the label positioning, but this feature will become available in 4.1.0.

### `ClearWayType`

`ClearWayType` has been deprecated with the introduction of multiple `wayType` categories, going forward you should use `ClearAvoidWayType` instead.

{% tabs %}
{% tab title="Before" %}

```dart
final service = MPDirectionsService();
service.addAvoidWayType(MPHighway.steps.name);
service.addExcludeWayType(MPHighway.ladder.name);
service.clearWayType(); // What was cleared?
```

{% endtab %}

{% tab title="After" %}

```dart
final service = MPDirectionsService();
service.addAvoidWayType(MPHighway.steps.name);
service.addExcludeWayType(MPHighway.ladder.name);
service.clearAvoidWayType(); // AvoidWayTypes were cleared!
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.mapsindoors.com/sdks-and-frameworks/flutter/migration-guide.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
